#include "stdafx.h"
#include "Datum.h"
#include <stdio.h>

Datum::Datum(int _den, int _mesic, int _rok)
{
	posledni_dny[0] = 31; // leden
	posledni_dny[1] = 28;
	posledni_dny[2] = 31;
	posledni_dny[3] = 30;
	posledni_dny[4] = 31;
	posledni_dny[5] = 30;
	posledni_dny[6] = 31;
	posledni_dny[7] = 31;
	posledni_dny[8] = 30;
	posledni_dny[9] = 31;
	posledni_dny[10] = 30;
	posledni_dny[11] = 31; // prosinec

	// pokud rok je prestupny, zmenime si docasne posledni den v unoru na 29
	if (_rok % 4 == 0 || _rok % 100 == 0)
		posledni_dny[1] = 29;

	if (_mesic < 1 || _mesic > 12 || _den < 1	|| _den > posledni_dny[_mesic-1])
	{
		puts("Spatne datum");
	}
	else
	{
		// v poradku, prirazujeme
		den = _den;
		mesic = _mesic;
		rok = _rok;
	}

	// zpet na neprestupny rok
	posledni_dny[1] = 28;
}

void Datum::dalsi()
{
	// pokud rok je prestupny, zmenime si docasne posledni den v unoru na 29
	if (rok % 4 == 0 || rok % 100 == 0)
		posledni_dny[1] = 29;

	// zvysime den
	den++;
	if (den > posledni_dny[mesic - 1])
	{
		// den prelezl povoleny pocet dni v danem mesici, jdeme na prvni den
		// nasledujiciho mesice
		den = 1;
		mesic++;

		if (mesic > 12)
		{
			// zvednutim na nasledujici mesic jsme prelezli i prosinec, jdeme zpet na
			// leden a zvedame rok
			mesic = 1;
			rok++;
		}
	}
	// zpet na neprestupny rok
	posledni_dny[1] = 28;
}

void Datum::vypis() const
{
	printf("%d. %d. %d	", den, mesic, rok);
}
